#
# $Id: amrita_publisher.rb,v 1.1 2004/01/17 12:02:26 hn Exp $
# Copyright Narushima Hironori. All rights reserved.
#

require 'cgi'
require 'amrita/template'
require 'webpub/publisher'
require 'webpub/abstorel_filter'

=begin

TODO: complete equipment command line tools

* reading HTGenerationDescription and to create as that datas.

=end

#
# For amrita 1.0.2
#
def rexml_new_version?
	begin
		REXML::File.class
		false
	rescue NameError
		true
	end
end

if rexml_new_version?
	module REXML
		class File < String
			def initialize(path)
				super IO.read(path)
			end
		end
	end
end

module WebPub

=begin

=end
class AmritaPublisher < Publisher

	include Amrita

	def initialize
	end

	def publish( desc)
		begin
			do_publish(desc)
		rescue Exception 
			err = $!.dup
			
			open( desc.publish_to, 'w') { |fh|
				fh << "<body><h4><pre>#{CGI.escapeHTML(err.message)}</pre></h4>"
				fh << %Q!<pre>#{CGI.escapeHTML(err.backtrace.join("\n"))}</pre>!
				fh << '</body>'
			}
			
			raise err.class, err.message, err.backtrace
		end
	end

	protected
	
	def do_publish(desc)
		tmpl = create_template(desc)
		config_tmplate(tmpl, desc)
		memberobj = create_memberobj(desc)
		
		lines = ''
		tmpl.expand(lines, memberobj)
		
		ht_distribute(desc, lines)
	end

	def create_memberobj( desc)
		prop = desc.arguments
		load File.join( desc.web_project.scripts_dir, prop['script'])
		klass_name = prop['class']
		method = prop['method']
		
		if klass_name
			klass = eval(klass_name)
			m = klass.instance_method(:initialize)
			member_obj = m.arity != 0 ? klass.new(desc) : klass.new
			if method
				member_obj.send(method)
			else
				member_obj
			end
		elsif method
			eval(method)
		else
			raise "Invalid arguments by amrita (not specify both class and method):#{desc.inspect}"
		end
	end
	
	def create_template( desc )
		TemplateFile.new( desc.publish_from )
	end

	def config_tmplate( tmpl, desc)
		args = desc.arguments
		tmpl.expand_attr = args['expand_attr'] == 'false' ? false : true if tmpl.respond_to?('expand_attr=')
		
		tmpl.xml = args['xml'] == 'true' ? true : false
		tmpl.asxml = args['asxml'] == 'true' ? true : false
		
		tmpl.compact_space = args['compact_space'] == 'true' ? true : false if tmpl.respond_to?('compact_space=')
		tmpl.prettyprint = args['prettyprint'] == 'true' ? true : false if tmpl.respond_to?('prettyprint=')
	end
end

end